#ifndef SOCKET_H
#define SOCKET_H

#include <sys/socket.h>
#include <netinet/in.h>
//#include "musicstring.h"
#include <string>

class InAddr {
public:
  virtual ~InAddr() { };
  virtual void set_port(int port)=0;
  static InAddr *resolv(const char *name);
  virtual string tostring() = 0;
  virtual sockaddr * addr()=0;
  virtual socklen_t addr_len() = 0;
  virtual int af()=0;
};

class InAddr4 : public InAddr {
  struct sockaddr_in s;
public:
  InAddr4(struct in_addr *si) {
    s.sin_family = AF_INET;
    s.sin_port = 0;
    s.sin_addr = *si;
  }
  virtual ~InAddr4() { };
  void set_port(int port) { s.sin_port = htons(port); };
  virtual string tostring() {
    return inet_ntoa(s.sin_addr);
  }
  sockaddr *addr() {
    return (sockaddr*)&s;
  }
  socklen_t addr_len() {
    return sizeof s;
  }
  int af() { return AF_INET; };
};

class Socket {
  int fd;
  struct sockaddr_in address;
  bool dead;
  string buffer;
 public:
  Socket();
  int connect(InAddr *where);
  int read(char *, int);
  int write(const char *, int);
  void close();
  virtual ~Socket();
  int getfd() { return fd; }
};

#endif
